import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import { UndoStack } from '@mescius/wijmo.undo';
import { ComboBox, InputNumber, InputDate, AutoComplete, MultiSelect, MultiAutoComplete } from '@mescius/wijmo.input';
import { FlexGrid } from '@mescius/wijmo.grid';
import { RadialGauge, NeedleLength, NeedleShape, ShowText } from '@mescius/wijmo.gauge';
import { CellRangeEventArgs } from '@mescius/wijmo.grid';
document.readyState === 'complete' ? init() : window.onload = init;
function init() {
// create controls
new ComboBox('#country', {
itemsSource: getCountries(),
isRequired: false,
selectedIndex: -1
});
new InputNumber('#amount', {
format: 'c2',
min: 0,
step: 10,
isRequired: false,
value: null
});
new InputDate('#date', {
isRequired: false,
value: null
});
new ComboBox('#color', {
itemsSource: getColors(),
isRequired: false,
selectedIndex: -1
});
new AutoComplete('#ac', {
itemsSource: getColors(),
selectedIndex: -1
});
new MultiSelect('#colors', {
itemsSource: getColors()
});
new MultiAutoComplete('#mac', {
itemsSource: getColors(),
selectedIndex: -1
});
new RadialGauge('#gauge', {
thickness: .2,
min: 0,
max: 100,
value: 50,
isReadOnly: false,
tickSpacing: 10,
showTicks: true,
showText: ShowText.Value,
needleShape: NeedleShape.Outer,
needleLength: NeedleLength.Inner
});
// add a grid
let g = new FlexGrid('#grid', {
anchorCursor: true,
frozenColumns: 2,
allowAddNew: true,
allowDelete: true,
itemsSource: getData(),
});
// add some data maps
let col = g.getColumn('name');
col.dataMap = getNames();
col.dataMap.isEditable = true;
col = g.getColumn('country');
col.dataMap = getCountries();
// add/delete grid rows in code
document.getElementById('add-row').addEventListener('click', (e) => {
g.focus();
let view = g.editableCollectionView;
let newItem = view.addNew();
newItem.id = -1;
newItem.name = 'new item';
newItem.active = true;
g.onRowAdded(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.commitNew();
e.preventDefault(); // don't submit the form
});
document.getElementById('del-row').addEventListener('click', (e) => {
g.focus();
let view = g.editableCollectionView;
if (view.items.length) {
let sel = g.selection;
if (sel.row > -1) {
let item = g.rows[sel.row].dataItem;
g.onDeletingRow(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.remove(item);
}
}
e.preventDefault(); // don't submit the form
});
document.getElementById('nr-top').addEventListener('click', (e) => {
g.newRowAtTop = e.target.checked;
});
// create undo/redo buttons
let btnUndo = document.getElementById('undo');
let btnRedo = document.getElementById('redo');
let btnClear = document.getElementById('clear');
let cnt = document.getElementById('undo-cnt');
// create undo stack
let undoStack = new UndoStack('#undoable-form', {
maxActions: 50,
stateChanged: (s) => {
btnUndo.disabled = !s.canUndo;
btnRedo.disabled = !s.canRedo;
btnClear.disabled = !s.actionCount;
cnt.textContent = s.actionCount.toString();
},
});
// hook up undo/redo/clear buttons
btnUndo.addEventListener('click', () => {
undoStack.undo();
});
btnRedo.addEventListener('click', () => {
undoStack.redo();
});
btnClear.addEventListener('click', () => {
undoStack.clear();
});
// create some data
function getColors() {
return 'Black,Blue,Brown,Green,Magenta,Orange,Pink,Purple,Red,Teal,Violet,White,Yellow'.split(',');
}
function getCountries() {
return 'US,Germany,UK,Japan,Italy,Greece'.split(',');
}
function getNames() {
return 'Abe,Bob,Chuck,Dan,Ed,Fred'.split(',');
}
function getData() {
let countries = getCountries(), names = getNames(), data = [];
for (let i = 0; i < 50; i++) {
data.push({
id: i,
name: names[i % names.length],
country: countries[i % countries.length],
active: i % 5 != 0,
downloads: Math.round(Math.random() * 200000),
sales: Math.round(Math.random() * 20000),
});
}
return data;
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo UndoStack</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<!-- undo/redo toolbar -->
<div class="toolbar">
<button id="undo" class="btn btn-primary" disabled>
<span class="arrow">↶</span> Undo (ctrl+Z)
</button>
<button id="redo" class="btn btn-primary" disabled>
<span class="arrow">↷</span> Redo (ctrl+Y)
</button>
<button class="btn" disabled>
Action Count: <span id="undo-cnt">0</span>
</button>
<button id="clear" class="btn btn-default" disabled>
Clear Undo/Redo Stack
</button>
</div>
<!-- undo/redo form -->
<form id="undoable-form">
<div class="row">
<!-- HTML input elements -->
<div class="col-md-5">
<h3>HTML Input Elements</h3>
<div class="form-group">
<label for="firstName">First Name</label>
<input id="firstName" class="form-control" placeholder="First Name" />
</div>
<div class="form-group">
<label for="lastName">Last Name</label>
<input id="lastName" class="form-control" placeholder="Last Name"/>
</div>
<div class="form-group">
<label for="select">Select</label>
<select id="select" class="form-control">
<option value="value1">Apples</option>
<option value="value2" selected>Oranges</option>
<option value="value3">Grapes</option>
</select>
</div>
<div class="form-group">
<label for="area">TextArea</label>
<textarea id="area" class="form-control" placeholder="textarea"></textarea>
</div>
<div class="form-group label-indent">
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox1" value="option1" checked> Red
</label>
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox2" value="option2"> Green
</label>
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox3" value="option3"> Blue
</label>
</div>
<div class="form-group label-indent">
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio1" value="option1" checked>
Hot
</label>
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio2" value="option2"> Cold
</label>
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio3" value="option3"> Medium
</label>
</div>
</div>
<!-- Wijmo controls -->
<div class="col-md-7">
<h3>Wijmo Controls</h3>
<div class="form-group">
<label for="country">Country</label>
<div id="country" placeholder="Country"></div>
</div>
<div class="form-group">
<label for="amount">Amount</label>
<div id="amount" placeholder="Amount"></div>
</div>
<div class="form-group">
<label for="date">Date</label>
<div id="date" placeholder="Date"></div>
</div>
<div class="form-group">
<label for="color" title="ComboBox">Color</label>
<div id="color"></div>
</div>
<div class="form-group">
<label for="ac" title="AutoComplete">Color</label>
<div id="ac"></div>
</div>
<div class="form-group">
<label for="colors" title="MultiSelect">Colors</label>
<div id="colors"></div>
</div>
<div class="form-group">
<label for="mac" title="MultiAutoComplete">Colors</label>
<div id="mac"></div>
</div>
<div class="form-group">
<label for="gauge">Gauge</label>
<div id="gauge"></div>
</div>
<div class="form-group">
<label for="grid">Grid</label>
<div id="grid"></div>
<button type="button" id="add-row" class="btn btn-primary">
Add Row in Code
</button>
<button type="button" id="del-row" class="btn btn-primary">
Delete Row in Code
</button>
<label>
New Row At Top
<input id="nr-top" class="wj-no-undo" type="checkbox">
</label>
</div>
</div>
</div>
</form>
</div>
</body>
</html>
.toolbar {
position: sticky;
top: 0;
z-index: 10;
padding: 12px;
margin-left: -12px;
background: #eee;
}
.arrow {
display: inline-block;
transform: scale(2);
margin-right: 8px;
}
.form-group label {
min-width: 100px;
text-align: right;
margin-right: 12px;
}
.label-indent {
margin-left: 100px;
}
.label-indent label {
min-width: 0;
}
.form-control {
display: inline-block;
width: auto;
}
.btn {
outline: none !important;
}
.wj-dropdown, .wj-inputnumber {
width: 200px;
}
.wj-multi-autocomplete {
width: 300px;
}
.wj-flexgrid {
height: 250px;
}
.wj-radialgauge {
display: inline-block;
width: 200px;
}
.wj-gauge .wj-needle {
fill: orangered;
stroke: orangered;
}
.wj-gauge .wj-needle .wj-inner-needle-cap {
fill: white;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="app container-fluid">
<!-- undo toolbar -->
<div class="toolbar">
<button id="undo" class="btn btn-primary" :disabled="!canUndo" @click="undoStack.undo()">
<span class="arrow">↶</span> Undo (ctrl+Z)
</button>
<button id="redo" class="btn btn-primary" :disabled="!canRedo" @click="undoStack.redo()">
<span class="arrow">↷</span> Redo (ctrl+Y)
</button>
<button class="btn" disabled>
Action Count: {{ actionCount }}
</button>
<button id="clear" class="btn btn-default" :disabled="!actionCount" @click="undoStack.clear()">
Clear Undo/Redo Stack
</button>
</div>
<!-- undoable form -->
<form id="undoable-form">
<div class="row">
<!-- HTML input elements -->
<div class="col-md-5">
<h3>HTML Input Elements</h3>
<div class="form-group">
<label for="firstName">First Name</label>
<input id="firstName" class="form-control" placeholder="First Name" />
</div>
<div class="form-group">
<label for="lastName">Last Name</label>
<input id="lastName" class="form-control" placeholder="Last Name" />
</div>
<div class="form-group">
<label for="select">Select</label>
<select id="select" class="form-control">
<option value="value1">Apples</option>
<option value="value2" selected>Oranges</option>
<option value="value3">Grapes</option>
</select>
</div>
<div class="form-group">
<label for="area">TextArea</label>
<textarea id="area" class="form-control" placeholder="textarea"></textarea>
</div>
<div class="form-group label-indent">
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox1" value="option1" checked /> Red
</label>
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox2" value="option2" /> Green
</label>
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox3" value="option3" /> Blue
</label>
</div>
<div class="form-group label-indent">
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio1" value="option1" checked />
Hot
</label>
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio2" value="option2" /> Cold
</label>
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio3" value="option3" /> Medium
</label>
</div>
</div>
<!-- Wijmo controls -->
<div class="col-md-7">
<h3>Wijmo Controls</h3>
<div class="form-group">
<label for="country">Country</label>
<wj-combo-box id="country" placeholder="Country" :itemsSource="countries" :isRequired="false"
:selectedIndex="-1" />
</div>
<div class="form-group">
<label for="amount">Amount</label>
<wj-input-number id="amount" placeholder="Amount" :format="'c2'" :min="0" :step="10"
:isRequired="false" :value="null" />
</div>
<div class="form-group">
<label for="date">Date</label>
<wj-input-date id="date" placeholder="Date" :isRequired="false" :value="null" />
</div>
<div class="form-group">
<label for="color" title="ComboBox">Color</label>
<wj-combo-box id="color" :itemsSource="colors" :isRequired="false" :selectedIndex="-1" />
</div>
<div class="form-group">
<label for="ac" title="AutoComplete">Color</label>
<wj-auto-complete id="ac" :itemsSource="colors" :selectedIndex="-1" />
</div>
<div class="form-group">
<label for="colors" title="MultiSelect">Colors</label>
<wj-multi-select id="colors" :itemsSource="colors" />
</div>
<div class="form-group">
<label for="mac" title="MultiAutoComplete">Colors</label>
<wj-multi-auto-complete id="mac" :itemsSource="colors" :selectedIndex="-1" />
</div>
<div class="form-group">
<label for="gauge">Gauge</label>
<wj-radial-gauge :thickness=".2" :min="0" :max="100" :value="50" :isReadOnly="false"
:tickSpacing="10" :showTicks="true" :showText="'Value'" :needleShape="'Outer'"
:needleLength="'Inner'" />
</div>
<div class="form-group">
<label for="grid">Grid</label>
<wj-flex-grid div id="grid" :anchorCursor="true" :frozenColumns="2" :allowAddNew="true"
:allowDelete="true" :itemsSource="data" :initialized="initGrid" />
<button type="button" id="add-row" class="btn btn-primary" @click="addRow($event)">
Add Row in Code
</button>
<button type="button" id="del-row" class="btn btn-primary" @click="deleteRow($event)">
Delete Row in Code
</button>
<label>
New Row At Top
<input id="nr-top" class="wj-no-undo" type="checkbox"
@click="grid.newRowAtTop = $event.target.checked" />
</label>
</div>
</div>
</div>
</form>
</div>
</template>
<script setup>
import "src/app.css";
import { UndoStack } from "@mescius/wijmo.undo";
import { CellRangeEventArgs } from "@mescius/wijmo.grid";
import { ref, onMounted } from "vue";
const undoStack = ref(null);
const grid = ref(null);
const data = ref(getData());
const colors = ref(getColors());
const countries = ref(getCountries());
const names = ref(getNames());
const canUndo = ref(false);
const canRedo = ref(false);
const actionCount = ref(0);
onMounted(function () // enable undo/redo for the form
{
undoStack.value = new UndoStack("#undoable-form", {
maxActions: 50,
stateChanged: (s) => {
canUndo.value = s.canUndo;
canRedo.value = s.canRedo;
actionCount.value = s.actionCount;
},
});
});
// initialize grid
function initGrid(s) {
// save reference to the grid
grid.value = s;
// add data maps to some columns
let col = s.getColumn("name");
col.dataMap = names.value;
col.dataMap.isEditable = true;
col = s.getColumn("country");
col.dataMap = countries.value;
}
// add a row in code, calling "onRowAdded" to enable undo for this action
function addRow(e) {
let g = grid.value;
g.focus();
let view = g.collectionView;
let newItem = view.addNew();
newItem.id = -1;
newItem.name = "new item";
newItem.active = true;
g.onRowAdded(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action, it also commit the changes
e.preventDefault(); // don't submit the form
}
// delete a row in code, calling "onDeletingRow" to enable undo for this action
function deleteRow(e) {
let g = grid.value,
view = g.editableCollectionView;
g.focus();
if (view.items.length) {
let sel = g.selection;
if (sel.row > -1) {
let item = g.rows[sel.row].dataItem;
g.onDeletingRow(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.remove(item);
}
}
e.preventDefault(); // don't submit the form
}
// generate some data for the sample
function getColors() {
return "Black,Blue,Brown,Green,Magenta,Orange,Pink,Purple,Red,Teal,Violet,White,Yellow".split(",");
}
function getCountries() {
return "US,Germany,UK,Japan,Italy,Greece".split(",");
}
function getNames() {
return "Abe,Bob,Chuck,Dan,Ed,Fred".split(",");
}
function getData() {
let countries = getCountries(),
names = getNames(),
data = [];
for (let i = 0; i < 50; i++) {
data.push({
id: i,
name: names[i % names.length],
country: countries[i % countries.length],
active: i % 5 != 0,
downloads: Math.round(Math.random() * 200000),
sales: Math.round(Math.random() * 20000),
});
}
return data;
}
</script>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo UndoStack</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import '@angular/compiler';
import { Component, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { WjGaugeModule } from '@mescius/wijmo.angular2.gauge';
import { UndoStack } from '@mescius/wijmo.undo';
import { FlexGrid, CellRangeEventArgs } from '@mescius/wijmo.grid';
@Component({
standalone: true,
imports: [WjInputModule, WjGridModule, WjGaugeModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
undoStack: UndoStack;
grid: FlexGrid;
data = this.getData();
colors = this.getColors();
countries = this.getCountries();
names = this.getNames();
canUndo = false;
canRedo = false;
actionCount = 0;
// enable undo/redo for the form
// use ngAfterViewInit to ensure all controls
// have been initalized (ngOnInit is too soon)
ngAfterViewInit() {
this.undoStack = new UndoStack('#undoable-form', {
maxActions: 50,
stateChanged: (s: UndoStack) => {
this.canUndo = s.canUndo;
this.canRedo = s.canRedo;
this.actionCount = s.actionCount;
},
});
}
// initialize the grid
initGrid(s: FlexGrid) {
// save reference to the grid
this.grid = s;
// add data maps to some columns
let col = s.getColumn('name');
col.dataMap = this.names as any;
col.dataMap.isEditable = true;
col = s.getColumn('country');
col.dataMap = this.countries as any;
}
// add a row in code, calling "onRowAdded" to enable undo for this action
addRow(e: MouseEvent) {
let g = this.grid,
view = g.editableCollectionView,
newItem = view.addNew();
g.focus();
newItem.id = -1;
newItem.name = 'new item';
newItem.active = true;
g.onRowAdded(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.commitNew();
e.preventDefault(); // don't submit the form
}
// delete a row in code, calling "onDeletingRow" to enable undo for this action
deleteRow(e: MouseEvent) {
let g = this.grid,
view = g.editableCollectionView;
g.focus();
if (view.items.length) {
let sel = g.selection;
if (sel.row > -1) {
let item = g.rows[sel.row].dataItem;
g.onDeletingRow(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.remove(item);
}
}
e.preventDefault(); // don't submit the form
}
// provide some data for the sample
getColors() {
return 'Black,Blue,Brown,Green,Magenta,Orange,Pink,Purple,Red,Teal,Violet,White,Yellow'.split(',');
}
getCountries() {
return 'US,Germany,UK,Japan,Italy,Greece'.split(',');
}
getNames() {
return 'Abe,Bob,Chuck,Dan,Ed,Fred'.split(',');
}
getData() {
let countries = this.getCountries(),
names = this.getNames(),
data = [];
for (let i = 0; i < 50; i++) {
data.push({
id: i,
name: names[i % names.length],
country: countries[i % countries.length],
active: i % 5 != 0,
downloads: Math.round(Math.random() * 200000),
sales: Math.round(Math.random() * 20000),
});
}
return data;
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo UndoStack</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<!-- undo/redo toolbar -->
<div class="toolbar">
<button id="undo" class="btn btn-primary"
[disabled]="!canUndo"
(click)="undoStack.undo()">
<span class="arrow">↶</span> Undo (ctrl+Z)
</button>
<button id="redo" class="btn btn-primary"
[disabled]="!canRedo"
(click)="undoStack.redo()">
<span class="arrow">↷</span> Redo (ctrl+Y)
</button>
<button class="btn" disabled>
Action Count: {{actionCount}}
</button>
<button id="clear" class="btn btn-default"
[disabled]="!actionCount"
(click)="undoStack.clear()">
Clear Undo/Redo Stack
</button>
</div>
<!-- undo/redo form -->
<form id="undoable-form">
<div class="row">
<!-- HTML input elements -->
<div class="col-md-5">
<h3>HTML Input Elements</h3>
<div class="form-group">
<label for="firstName">First Name</label>
<input id="firstName" class="form-control" placeholder="First Name" />
</div>
<div class="form-group">
<label for="lastName">Last Name</label>
<input id="lastName" class="form-control" placeholder="Last Name"/>
</div>
<div class="form-group">
<label for="select">Select</label>
<select id="select" class="form-control">
<option value="value1">Apples</option>
<option value="value2" selected>Oranges</option>
<option value="value3">Grapes</option>
</select>
</div>
<div class="form-group">
<label for="area">TextArea</label>
<textarea id="area" class="form-control" placeholder="textarea"></textarea>
</div>
<div class="form-group label-indent">
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox1" value="option1" checked> Red
</label>
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox2" value="option2"> Green
</label>
<label class="checkbox-inline">
<input type="checkbox" id="inlineCheckbox3" value="option3"> Blue
</label>
</div>
<div class="form-group label-indent">
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio1" value="option1" checked>
Hot
</label>
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio2" value="option2"> Cold
</label>
<label class="radio-inline">
<input type="radio" name="inlineRadioOptions" id="inlineRadio3" value="option3"> Medium
</label>
</div>
</div>
<!-- Wijmo controls -->
<div class="col-md-7">
<h3>Wijmo Controls</h3>
<div class="form-group">
<label for="country">Country</label>
<wj-combo-box id="country" placeholder="Country"
[itemsSource]="countries"
[isRequired]="false"
[selectedIndex]="-1">
</wj-combo-box>
</div>
<div class="form-group">
<label for="amount">Amount</label>
<wj-input-number id="amount" placeholder="Amount"
[format]="'c2'"
[min]="0"
[step]="10"
[isRequired]="false"
[value]="null">
</wj-input-number>
</div>
<div class="form-group">
<label for="date">Date</label>
<wj-input-date id="date" placeholder="Date"
[isRequired]="false"
[value]="null">
</wj-input-date>
</div>
<div class="form-group">
<label for="color" title="ComboBox">Color</label>
<wj-combo-box id="color"
[itemsSource]="colors"
[isRequired]="false"
[selectedIndex]="-1">
</wj-combo-box>
</div>
<div class="form-group">
<label for="ac" title="AutoComplete">Color</label>
<wj-auto-complete id="ac"
[itemsSource]="colors"
[selectedIndex]="-1">
</wj-auto-complete>
</div>
<div class="form-group">
<label for="colors" title="MultiSelect">Colors</label>
<wj-multi-select id="colors"
[itemsSource]="colors">
</wj-multi-select>
</div>
<div class="form-group">
<label for="mac" title="MultiAutoComplete">Colors</label>
<wj-multi-auto-complete id="mac"
[itemsSource]="colors"
[selectedIndex]="-1">
</wj-multi-auto-complete>
</div>
<div class="form-group">
<label for="gauge">Gauge</label>
<wj-radial-gauge
[thickness]=".2"
[min]="0"
[max]="100"
[value]="50"
[isReadOnly]="false"
[tickSpacing]="10"
[showTicks]="true"
[showText]="'Value'"
[needleShape]="'Outer'"
[needleLength]="'Inner'">
</wj-radial-gauge>
</div>
<div class="form-group">
<label for="grid">Grid</label>
<wj-flex-grid div id="grid" #theGrid
[anchorCursor]="true"
[frozenColumns]="2"
[allowAddNew]="true"
[allowDelete]="true"
[itemsSource]="data"
(initialized)="initGrid(theGrid)">
</wj-flex-grid>
<button type="button" id="add-row" class="btn btn-primary" (click)="addRow($event)">
Add Row in Code
</button>
<button type="button" id="del-row" class="btn btn-primary" (click)="deleteRow($event)">
Delete Row in Code
</button>
<label>
New Row At Top
<input id="nr-top" class="wj-no-undo" type="checkbox"
[checked]="grid && grid.newRowAtTop"
(change)="grid.newRowAtTop = !grid.newRowAtTop">
</label>
</div>
</div>
</div>
</form>
</div>
.toolbar {
position: sticky;
top: 0;
z-index: 10;
padding: 12px;
margin-left: -12px;
background: #eee;
}
.arrow {
display: inline-block;
transform: scale(2);
margin-right: 8px;
}
.form-group label {
min-width: 100px;
text-align: right;
margin-right: 12px;
}
.label-indent {
margin-left: 100px;
}
.label-indent label {
min-width: 0;
}
.form-control {
display: inline-block;
width: auto;
}
.btn {
outline: none !important;
margin-right: 6px;
}
.wj-dropdown, .wj-inputnumber {
width: 200px;
}
.wj-multi-autocomplete {
width: 300px;
}
.wj-flexgrid {
height: 250px;
}
.wj-radialgauge {
display: inline-block;
width: 200px;
}
.wj-gauge .wj-needle {
fill: orangered;
stroke: orangered;
}
.wj-gauge .wj-needle .wj-inner-needle-cap {
fill: white;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import React, { useEffect, useRef, useState } from 'react';
import * as ReactDOM from 'react-dom/client';
import { ComboBox, InputNumber, InputDate, AutoComplete, MultiAutoComplete, MultiSelect } from '@mescius/wijmo.react.input';
import { RadialGauge } from '@mescius/wijmo.react.gauge';
import { FlexGrid } from '@mescius/wijmo.react.grid';
import { CellRangeEventArgs } from '@mescius/wijmo.grid';
import { UndoStack } from '@mescius/wijmo.undo';
import './app.css';
import { colors, countries, names, data } from './data';
function App() {
const [canUndo, setCanUndo] = useState(false);
const [canRedo, setCanRedo] = useState(false);
const [actionCount, setActionCount] = useState(0);
const undoStackRef = useRef(null);
const gridRef = useRef(null);
const countryCombo = useRef(null);
const inputNumber = useRef(null);
const inputDate = useRef(null);
const colorCombo = useRef(null);
const autoComplete = useRef(null);
const multiAutoComplete = useRef(null);
const gauge = useRef(null);
// enable undo/redo for the form
useEffect(() => {
undoStackRef.current = new UndoStack('#undoable-form', {
maxActions: 50,
stateChanged: (s) => {
setCanUndo(s.canUndo);
setCanRedo(s.canRedo);
setActionCount(s.actionCount);
}
});
countryCombo.current.control.selectedIndex = -1;
inputNumber.current.control.value = null;
inputDate.current.control.value = null;
colorCombo.current.control.selectedIndex = -1;
autoComplete.current.control.selectedIndex = -1;
gauge.current.control.value = 50;
}, []);
return (<div className="container-fluid">
{/* undo toolbar */}
<div className="toolbar">
<button id="undo" className="btn btn-primary" disabled={!canUndo} onClick={() => { var _a; return (_a = undoStackRef.current) === null || _a === void 0 ? void 0 : _a.undo(); }}>
<span className="arrow">↶</span> Undo (ctrl+Z)
</button>{' '}
<button id="redo" className="btn btn-primary" disabled={!canRedo} onClick={() => { var _a; return (_a = undoStackRef.current) === null || _a === void 0 ? void 0 : _a.redo(); }}>
<span className="arrow">↷</span> Redo (ctrl+Y)
</button>{' '}
<button className="btn" disabled>
Action Count: {actionCount}
</button>{' '}
<button id="clear" className="btn btn-default" disabled={!actionCount} onClick={() => { var _a; return (_a = undoStackRef.current) === null || _a === void 0 ? void 0 : _a.clear(); }}>
Clear Undo/Redo Stack
</button>
</div>
{/* undoable form */}
<form id="undoable-form">
<div className="row">
{/* HTML input elements */}
<div className="col-md-5">
<h3>HTML Input Elements</h3>
<div className="form-group">
<label htmlFor="firstName">First Name</label>
<input id="firstName" className="form-control" placeholder="First Name"/>
</div>
<div className="form-group">
<label htmlFor="lastName">Last Name</label>
<input id="lastName" className="form-control" placeholder="Last Name"/>
</div>
<div className="form-group">
<label htmlFor="select">Select</label>
<select id="select" className="form-control" defaultValue={"value2"}>
<option value="value1">Apples</option>
<option value="value2">Oranges</option>
<option value="value3">Grapes</option>
</select>
</div>
<div className="form-group">
<label htmlFor="area">TextArea</label>
<textarea id="area" className="form-control" placeholder="textarea"></textarea>
</div>
<div className="form-group label-indent">
<label className="checkbox-inline">
<input type="checkbox" value="red" defaultChecked={true}/> Red
</label>
<label className="checkbox-inline">
<input type="checkbox" value="green"/> Green
</label>
<label className="checkbox-inline">
<input type="checkbox" value="blue"/> Blue
</label>
</div>
<div className="form-group label-indent">
<label className="radio-inline">
<input type="radio" name="radio" value="hot" defaultChecked={true}/> Hot
</label>
<label className="radio-inline">
<input type="radio" name="radio" value="cold"/> Cold
</label>
<label className="radio-inline">
<input type="radio" name="radio" value="medium"/> Medium
</label>
</div>
</div>
{/* Wijmo controls */}
<div className="col-md-7">
<h3>Wijmo Controls</h3>
<div className="form-group">
<label htmlFor="country">Country</label>
<ComboBox ref={countryCombo} id="country" placeholder="Country" itemsSource={countries} isRequired={false}/>
</div>
<div className="form-group">
<label htmlFor="amount">Amount</label>
<InputNumber ref={inputNumber} id="amount" placeholder="Amount" format="c2" min={0} step={10} isRequired={false}/>
</div>
<div className="form-group">
<label htmlFor="date">Date</label>
<InputDate ref={inputDate} id="date" placeholder="Date" isRequired={false}/>
</div>
<div className="form-group">
<label htmlFor="color" title="ComboBox">Color</label>
<ComboBox ref={colorCombo} id="color" itemsSource={colors} isRequired={false}/>
</div>
<div className="form-group">
<label htmlFor="ac" title="AutoComplete">Color</label>
<AutoComplete ref={autoComplete} id="ac" itemsSource={colors}/>
</div>
<div className="form-group">
<label htmlFor="colors" title="MultiSelect">Colors</label>
<MultiSelect id="colors" itemsSource={colors}/>
</div>
<div className="form-group">
<label htmlFor="mac" title="MultiAutoComplete">Colors</label>
<MultiAutoComplete id="mac" itemsSource={colors} selectedIndex={-1}/>
</div>
<div className="form-group">
<label htmlFor="gauge">Gauge</label>
<RadialGauge ref={gauge} thickness={.2} min={0} max={100} isReadOnly={false} tickSpacing={10} showTicks={true} showText="Value" needleShape="Outer" needleLength="Inner"/>
</div>
<div className="form-group">
<label htmlFor="grid">Grid</label>
<FlexGrid id="grid" anchorCursor={true} frozenColumns={2} allowAddNew={true} allowDelete={true} itemsSource={data} initialized={(s) => {
// save reference to grid
gridRef.current = s;
// add data maps to some columns
let col = s.getColumn('name');
col.dataMap = names;
col.dataMap.isEditable = true;
col = s.getColumn('country');
col.dataMap = countries;
}}/>
<button type="button" id="add-row" className="btn btn-primary" onClick={(e) => {
let g = gridRef.current;
if (g) {
let view = g.editableCollectionView, newItem = view.addNew();
g.focus();
newItem.id = -1;
newItem.name = 'new item';
newItem.active = true;
g.onRowAdded(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.commitNew();
}
e.preventDefault(); // don't submit the form
}}>
Add Row in Code
</button>{' '}
<button type="button" id="del-row" className="btn btn-primary" onClick={(e) => {
let g = gridRef.current;
if (g) {
let view = g.editableCollectionView;
g.focus();
if (view.items.length) {
let sel = g.selection;
if (sel.row > -1) {
let item = g.rows[sel.row].dataItem;
g.onDeletingRow(new CellRangeEventArgs(g.cells, g.selection)); // create undoable action
view.remove(item);
}
}
}
e.preventDefault(); // don't submit the form
}}>
Delete Row in Code
</button>{' '}
<label>
New Row At Top{' '}
<input id="nr-top" className="wj-no-undo" type="checkbox" onChange={e => {
if (gridRef.current) {
gridRef.current.newRowAtTop = e.target.checked;
}
}}/>
</label>
</div>
</div>
</div>
</form>
</div>);
}
setTimeout(() => {
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
}, 100);
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo UndoStack</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.toolbar {
position: sticky;
top: 0;
z-index: 10;
padding: 12px;
margin-left: -12px;
background: #eee;
}
.arrow {
display: inline-block;
transform: scale(2);
margin-right: 8px;
}
.form-group label {
min-width: 100px;
text-align: right;
margin-right: 12px;
}
.label-indent {
margin-left: 100px;
}
.label-indent label {
min-width: 0;
}
.form-control {
display: inline-block;
width: auto;
}
.btn {
outline: none !important;
}
.wj-dropdown,
.wj-inputnumber {
width: 200px;
}
.wj-multi-autocomplete {
width: 300px;
}
.wj-flexgrid {
height: 250px;
}
.wj-radialgauge {
display: inline-block;
width: 200px;
}
.wj-gauge .wj-needle {
fill: orangered;
stroke: orangered;
}
.wj-gauge .wj-needle .wj-inner-needle-cap {
fill: white;
}
// create some data
const getColors = () => {
return 'Black,Blue,Brown,Green,Magenta,Orange,Pink,Purple,Red,Teal,Violet,White,Yellow'.split(',');
};
const getCountries = () => {
return ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
};
const getNames = () => {
return 'Abe,Bob,Chuck,Dan,Ed,Fred'.split(',');
};
const getData = () => {
let countries = getCountries(), names = getNames(), data = [];
for (let i = 0; i < 50; i++) {
data.push({
id: i,
name: names[i % names.length],
country: countries[i % countries.length],
active: i % 5 != 0,
downloads: Math.round(Math.random() * 200000),
sales: Math.round(Math.random() * 20000),
});
}
return data;
};
export const colors = getColors();
export const countries = getCountries();
export const names = getNames();
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);